/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements. See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership. The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the  "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.emje.treehtmlparse.alteredsourcestring;

/**
 *
 * @author Ammar Shadiq
 */
public class AddReplacedStringView extends javax.swing.JDialog {

    private static AddReplacedStringView addReplacedStringView;
    private static String[] replaceTextEdit;
    private static String[] replaceTextBackup;

    public AddReplacedStringView(java.awt.Frame parent, boolean modal,  String title, String containingText, String replaceWith) {
        super(parent, modal);

        initComponents();
        setTitle(title);

        if (containingText != null && replaceWith != null){
            replaceTextBackup = new String[]{containingText, replaceWith};
            this.containingTextField.setText(containingText);
            this.replaceWithTextField.setText(replaceWith);
        }
    }

    /** edit command */
    public static String[] showDialog(java.awt.Frame parent, boolean modal, String title, String containingText, String replaceWith){
        addReplacedStringView = new AddReplacedStringView (parent, modal, title, containingText, replaceWith);
        addReplacedStringView.setLocationRelativeTo(parent);
        addReplacedStringView.setVisible(true);
        return replaceTextEdit;
    }

    /** add command */
    public static String[] showDialog(java.awt.Frame parent, boolean modal, String title){
        addReplacedStringView = new AddReplacedStringView (parent, modal, title, null, null);
        addReplacedStringView.setLocationRelativeTo(parent);
        addReplacedStringView.setVisible(true);
        return replaceTextEdit;
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        containingLabel = new javax.swing.JLabel();
        containingTextField = new javax.swing.JTextField();
        replaceWithLabel = new javax.swing.JLabel();
        replaceWithTextField = new javax.swing.JTextField();
        cancelButton = new javax.swing.JButton();
        okButton = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setName("Form"); // NOI18N
        setResizable(false);

        containingLabel.setText(org.openide.util.NbBundle.getMessage(AddReplacedStringView.class, "AddReplacedStringView.containingLabel.text")); // NOI18N
        containingLabel.setName("containingLabel"); // NOI18N

        containingTextField.setText(org.openide.util.NbBundle.getMessage(AddReplacedStringView.class, "AddReplacedStringView.containingTextField.text")); // NOI18N
        containingTextField.setName("containingTextField"); // NOI18N
        containingTextField.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                containingTextFieldActionPerformed(evt);
            }
        });

        replaceWithLabel.setText(org.openide.util.NbBundle.getMessage(AddReplacedStringView.class, "AddReplacedStringView.replaceWithLabel.text")); // NOI18N
        replaceWithLabel.setName("replaceWithLabel"); // NOI18N

        replaceWithTextField.setText(org.openide.util.NbBundle.getMessage(AddReplacedStringView.class, "AddReplacedStringView.replaceWithTextField.text")); // NOI18N
        replaceWithTextField.setName("replaceWithTextField"); // NOI18N
        replaceWithTextField.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                replaceWithTextFieldActionPerformed(evt);
            }
        });

        cancelButton.setText(org.openide.util.NbBundle.getMessage(AddReplacedStringView.class, "AddReplacedStringView.cancelButton.text")); // NOI18N
        cancelButton.setName("cancelButton"); // NOI18N
        cancelButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                cancelButtonActionPerformed(evt);
            }
        });

        okButton.setText(org.openide.util.NbBundle.getMessage(AddReplacedStringView.class, "AddReplacedStringView.okButton.text")); // NOI18N
        okButton.setName("okButton"); // NOI18N
        okButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                okButtonActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(containingLabel)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(containingTextField, javax.swing.GroupLayout.DEFAULT_SIZE, 404, Short.MAX_VALUE))
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(replaceWithLabel)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(replaceWithTextField, javax.swing.GroupLayout.DEFAULT_SIZE, 404, Short.MAX_VALUE))
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                        .addComponent(okButton)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(cancelButton)))
                .addContainerGap())
        );

        layout.linkSize(javax.swing.SwingConstants.HORIZONTAL, new java.awt.Component[] {containingLabel, replaceWithLabel});

        layout.linkSize(javax.swing.SwingConstants.HORIZONTAL, new java.awt.Component[] {cancelButton, okButton});

        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(containingLabel)
                    .addComponent(containingTextField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(replaceWithLabel)
                    .addComponent(replaceWithTextField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(cancelButton)
                    .addComponent(okButton))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void cancelButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_cancelButtonActionPerformed
        // present the previous text string for the return value
        replaceTextEdit = replaceTextBackup;
        addReplacedStringView.setVisible(false);
        
        //close this window frame
        addReplacedStringView.dispose();
    }//GEN-LAST:event_cancelButtonActionPerformed

    private void okButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_okButtonActionPerformed
        // present the current text string for the return value
        this.containingTextField.getText();
        this.replaceWithTextField.getText();
        replaceTextEdit = new String[]{this.containingTextField.getText(), this.replaceWithTextField.getText()};
        replaceTextBackup = null;

        //close this window frame
        addReplacedStringView.setVisible(false);
        addReplacedStringView.dispose();
    }//GEN-LAST:event_okButtonActionPerformed

    private void containingTextFieldActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_containingTextFieldActionPerformed
        // do nothing, actually it should be changing the focus to replaceWtihTextField, but i dont know how :(
    }//GEN-LAST:event_containingTextFieldActionPerformed

    private void replaceWithTextFieldActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_replaceWithTextFieldActionPerformed
        okButtonActionPerformed(evt);
    }//GEN-LAST:event_replaceWithTextFieldActionPerformed

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton cancelButton;
    private javax.swing.JLabel containingLabel;
    private javax.swing.JTextField containingTextField;
    private javax.swing.JButton okButton;
    private javax.swing.JLabel replaceWithLabel;
    private javax.swing.JTextField replaceWithTextField;
    // End of variables declaration//GEN-END:variables

}
