/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements. See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership. The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the  "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.emje.treehtmlparse.htmltree.nodes;

/**
 *
 * @author Ammar Shadiq
 */
public interface HTMLComponent {

    /**
     * @return the Tag
     */
    public javax.swing.text.html.HTML.Tag getTag();

    /**
     * @param Tag the Tag to set
     */
    public void setTag(javax.swing.text.html.HTML.Tag tag);
    

    /**
     * @return the atributes
     */
    public javax.swing.text.MutableAttributeSet getAttributes();

    /**
     * @param atributes the atributes to set
     */
    public void setAttributes(javax.swing.text.MutableAttributeSet attributes);

    /**
     * @return the icon
     */
    public javax.swing.Icon getIcon();

    /**
     * @param icon the icon to set
     */
    public void setIcon(javax.swing.Icon icon);

    @Override
    public String toString();

}
