/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package org.emje.treehtmlparse.parser;

import java.util.ArrayList;
import java.util.Enumeration;
import java.util.Iterator;
import java.util.Map;
import java.util.TreeMap;
import javax.swing.tree.DefaultMutableTreeNode;
import javax.xml.namespace.QName;
import javax.xml.xpath.XPathConstants;
import org.emje.treehtmlparse.xpathtree.XPathTreeConfigInitialNodes;
import org.emje.treehtmlparse.xpathtree.nodes.XPathTreeConfigNode;
import org.emje.treehtmlparse.xpathtree.nodes.XPathTreeEntryNode;
import org.emje.treehtmlparse.xpathtree.nodes.XPathTreeFieldNode;
import org.w3c.dom.NodeList;

/**
 *
 * @author shadiq
 */
public class ConfResult {

    // Ada tiga jenis Object yang mungkin disini :
    // Jenis Pertama adalah jenis String biasa (Untuk Continous), yang artinya satu field hanya memiliki satu buah nilai, yaitu string
    // Jenis kedua adalah ArrayList (Untuk Segmented), yang artinya satu field memiliki berbagai jenis Object
    // Jenis ketiga adalah jenis TreeMap (Untuk Outlink) dengan URL sebagai Key dan Anchor sebagai Value

    // Jenis Kedua dapat diperluas lagi, Jika object pada ArrayList tersebut adalah : 
    // String biasa,
    // ArrayList of String (Untuk Nodeset) dan
    // TreeMap (Untuk Outlink)

    
//    Map<String, Object> fieldMap = new TreeMap();
    private HtmlParse parser;
    private String configName;

    public ConfResult(HtmlParse parser){
        this.parser = parser;
    }

    public Map<String, Object> getResult(XPathTreeConfigInitialNodes tree){

        Map<String, Object> fieldMap = new TreeMap();

        Enumeration en = tree.preorderEnumeration();
        while (en.hasMoreElements()) {
            DefaultMutableTreeNode node = (DefaultMutableTreeNode) en.nextElement();
            String objectName = node.getUserObject().getClass().getName();

            // if config
            if (objectName.matches("org.emje.treehtmlparse.xpathtree.nodes.XPathTreeConfigNode")) {
                XPathTreeConfigNode conf = (XPathTreeConfigNode) node.getUserObject();
                this.configName = conf.getName();

            // if field
            } else if (objectName.matches("org.emje.treehtmlparse.xpathtree.nodes.XPathTreeFieldNode")) {
                XPathTreeFieldNode field = (XPathTreeFieldNode) node.getUserObject();
                Enumeration enu = node.preorderEnumeration();

                if (field.getFieldType().equals(XPathTreeFieldNode.CONTINUOUS_TEXT)) {
                    System.out.println("continous");
                    StringBuilder sb = new StringBuilder();
                    while (enu.hasMoreElements()) {
                        DefaultMutableTreeNode n = (DefaultMutableTreeNode) enu.nextElement();
                        if (n.getUserObject().getClass().getName().
                                matches("org.emje.treehtmlparse.xpathtree.nodes.XPathTreeEntryNode")) {
                            XPathTreeEntryNode entry = (XPathTreeEntryNode) n.getUserObject();
                            sb.append((String) evaluateXPath(parser, entry.getxPathExpression(), entry.getExpressionType(),
                                    field.getFieldType(), field.getEntryDelimiter()));
                        }
                    }
                    sb.delete(sb.length() - field.getEntryDelimiter().length(), sb.length()); // remove the last delimiter
                    
                    fieldMap.put(field.getFieldName(), sb.toString().trim());


                } else if (field.getFieldType().equals(XPathTreeFieldNode.SEGMENTED_TEXT)) {
                    System.out.println("segmented");
                    ArrayList al = new ArrayList();

                    while (enu.hasMoreElements()) {
                        DefaultMutableTreeNode n = (DefaultMutableTreeNode) enu.nextElement();
                        if (n.getUserObject().getClass().getName().
                                matches("org.emje.treehtmlparse.xpathtree.nodes.XPathTreeEntryNode")) {
                            XPathTreeEntryNode entry = (XPathTreeEntryNode) n.getUserObject();
                            al.add(evaluateXPath(parser, entry.getxPathExpression(), entry.getExpressionType(),
                                    field.getFieldType(), field.getEntryDelimiter()));
                        }
                    }
                    fieldMap.put(field.getFieldName(), al);
                } else if (field.getFieldType().equals(XPathTreeFieldNode.OUTLINKS)) {
                    System.out.println("outlinks");
                    Map<String, String> outlinkMap = new TreeMap();
                    while (enu.hasMoreElements()) {
                        DefaultMutableTreeNode n = (DefaultMutableTreeNode) enu.nextElement();
                        if (n.getUserObject().getClass().getName().
                                matches("org.emje.treehtmlparse.xpathtree.nodes.XPathTreeEntryNode")) {
                            XPathTreeEntryNode entry = (XPathTreeEntryNode) n.getUserObject();

                            //temporary map for later merged with the outlinkMap
                            Map<String, String> tempMap = new TreeMap();
                            tempMap = (Map<String, String>) evaluateXPath(parser, entry.getxPathExpression(), entry.getExpressionType(),
                                    field.getFieldType(), field.getEntryDelimiter()); // get the outlinkMap of this entry
                            //iterati through all the tempMap and merge it into outlinkMap
                            Iterator tempMapIterator = tempMap.keySet().iterator();
                            while (tempMapIterator.hasNext()) {
                                String term = (String) tempMapIterator.next();
                                outlinkMap.put(term, tempMap.get(term));
                            }
                        }
                    }
                    fieldMap.put(field.getFieldName(), outlinkMap);
                }
            } //if entry IGNORE
        }

        return null;
    }

    private Object evaluateXPath(HtmlParse parser, String expression,
            String expressionType, String fieldType, String delimiter) {

        System.out.println(expression);

        // Evaluate XPath Expression with different returnType
        String XPathExpression = expression;
        QName returnType = null;
        Object xPathResult = null;
        Object xPathResultOutlinkAnchor = null;
        // <editor-fold defaultstate="collapsed" desc="Switch XPath Expression Return Type">
        if (expressionType.equals("xpath.string")) {
            returnType = XPathConstants.STRING;
            xPathResult = parser.evaluateXPathExpression(XPathExpression, returnType);
        } else if (expressionType.equals("xpath.node")) {
            returnType = XPathConstants.NODE;
            xPathResult = parser.evaluateXPathExpression(XPathExpression, returnType);
        } else if (expressionType.equals("xpath.nodeset")) {
            returnType = XPathConstants.NODESET;
            xPathResult = parser.evaluateXPathExpression(XPathExpression, returnType);
        } else if (expressionType.equals("xpath.number")) {
            returnType = XPathConstants.NUMBER;
            xPathResult = parser.evaluateXPathExpression(XPathExpression, returnType);
        } else if (expressionType.equals("xpath.boolean")) {
            returnType = XPathConstants.BOOLEAN;
            xPathResult = parser.evaluateXPathExpression(XPathExpression, returnType);
        } else if (expressionType.equals("xpath.string.normalized")) {
            returnType = XPathConstants.STRING;
            xPathResult = parser.evaluateXPathExpression("normalize-space(" + XPathExpression + ")", returnType);
        } else if (expressionType.equals("xpath.outlink.nodeset")) {
            returnType = XPathConstants.NODESET;
            if (XPathExpression.endsWith("/@href")) {
                XPathExpression = XPathExpression.substring(0, XPathExpression.length() - 6);
            }
            xPathResult = parser.evaluateXPathExpression(XPathExpression + "/@href", returnType);
            xPathResultOutlinkAnchor = parser.evaluateXPathExpression(XPathExpression + "/text()", returnType);
        } else if (expressionType.equals("plain.string")) {
            xPathResult = expression;
        } // </editor-fold>
        if (xPathResult != null) {
            // <editor-fold defaultstate="collapsed" desc="XPATH_OUTLINK_NODESET_ENTRY">
            if (expressionType.equals(XPathTreeEntryNode.XPATH_OUTLINK_NODESET_ENTRY)) {
                NodeList list = (NodeList) xPathResult;

                ArrayList<String> urlArrayList = new ArrayList<String>();
                ArrayList<String> anchorArrayList = new ArrayList<String>();

                // fill data
                if (xPathResultOutlinkAnchor != null) {
                    NodeList anchorList = (NodeList) xPathResultOutlinkAnchor;
                    for (int i = 0; i < list.getLength(); i++) {
                        String value = list.item(i).getNodeValue();
                        String anchorValue = "  ";
                        if (i < anchorList.getLength()) {
                            anchorValue = anchorList.item(i).getNodeValue().isEmpty() ? anchorList.item(i).getNodeValue() : "";

                        }
                        if (!value.matches("\\s+")) {
                            value = list.item(i).getNodeValue().replaceAll("\\s+", " "); // normalize space
                            if (!anchorValue.matches("\\s+")) {
                                anchorValue = anchorList.item(i).getNodeValue().replaceAll("\\s+", " "); // normalize space
                                urlArrayList.add(value);
                                anchorArrayList.add(anchorValue);
                            } else {
                                urlArrayList.add(value);
                                anchorArrayList.add("");
                            }
                        }
                    }
                } else {
                    for (int i = 0; i < list.getLength(); i++) {
                        String value = list.item(i).getNodeValue();
                        if (!value.matches("\\s+")) {
                            value = list.item(i).getNodeValue().replaceAll("\\s+", " "); // normalize space
                            urlArrayList.add(value);
                            anchorArrayList.add("");
                        }
                    }
                }
                Map<String, String> outlinkMap = new TreeMap();
                for (int k = 0; k < urlArrayList.size(); k++) {
                    outlinkMap.put((String) urlArrayList.get(k), (String) anchorArrayList.get(k));
                }
                return outlinkMap;
            }// </editor-fold>
            // <editor-fold defaultstate="collapsed" desc="XPATH_NODESET_ENTRY">
            else if (expressionType.equals(XPathTreeEntryNode.XPATH_NODESET_ENTRY)) {
                NodeList list = (NodeList) xPathResult;
                ArrayList<String> urlArrayList = new ArrayList<String>();

                // fill data
                for (int i = 0; i < list.getLength(); i++) {
                    String value = list.item(i).getNodeValue();
                    if (value != null && !value.matches("\\s+")) {
                        value = list.item(i).getNodeValue().replaceAll("\\s+", " "); // normalize space
                        urlArrayList.add(value);
                    }
                }

                if (fieldType.equals(XPathTreeFieldNode.CONTINUOUS_TEXT)) {
                    StringBuilder esbe = new StringBuilder();
                    for (int k = 0; k < urlArrayList.size(); k++) {
                        esbe.append((String) urlArrayList.get(k)).append(delimiter);
                    }
                    return esbe.toString();
                } else if (fieldType.equals(XPathTreeFieldNode.SEGMENTED_TEXT)) {
                    ArrayList<String> al = new ArrayList();
                    for (int k = 0; k < urlArrayList.size(); k++) {
                        al.add((String) urlArrayList.get(k));
                    }
                    return al;
                }
            }// </editor-fold>
            else {
                if (fieldType.equals(XPathTreeFieldNode.CONTINUOUS_TEXT)) {
                    return xPathResult.toString() + delimiter;
                } else if (fieldType.equals(XPathTreeFieldNode.SEGMENTED_TEXT)) {
                    return xPathResult.toString();
                }
            }
        }

        return null;
    }

    public String getConfigName(){
        return this.configName;
    }
}
